<?php

/* $Id: db.php 1760 2006-12-06 16:37:17Z b4rt $ */

/*******************************************************************************

 LICENSE

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License (GPL)
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 GNU General Public License for more details.

 To read the license please visit http://www.gnu.org/copyleft/gpl.html

*******************************************************************************/

// ADOdb
require_once('inc/lib/adodb/adodb.inc.php');

/**
 * initialize ADOdb-connection
 */
function initializeDatabase() {
	global $cfg, $db;
	// create ado-object
    $db = ADONewConnection($cfg["db_type"]);
    // connect
    if ($cfg["db_pcon"])
    	@ $db->PConnect($cfg["db_host"], $cfg["db_user"], $cfg["db_pass"], $cfg["db_name"]);
    else
    	@ $db->Connect($cfg["db_host"], $cfg["db_user"], $cfg["db_pass"], $cfg["db_name"]);
    // check for error
    if ($db->ErrorNo() != 0) {
    	global $argv;
    	if (isset($argv))
    		die("Error.\nCould not connect to database.\nCheck your database settings in the file config.db.php.\n");
    	else
    		showErrorPage("Could not connect to database.<br>Check your database settings in the file <em>config.db.php</em>.");
    }
}

/**
 * get ADOdb-connection
 *
 * @return ADOdb-connection
 */
function getdb() {
	global $db;
	if (isset($db)) {
		return $db;
	} else {
		initializeDatabase();
		return $db;
	}
}

/**
 * show db-error
 *
 * @param $db
 * @param $sql
 */
function showError($db, $sql) {
	global $cfg;
	if ($db->ErrorNo() != 0) {
		global $argv;
    	if (isset($argv)) {
    		$dieMessage = "Database-Error :\n";
    		$dieMessage .= $db->ErrorMsg();
    		if ($cfg["debug_sql"] == 1)
    			$dieMessage .= "\nSQL: ".$sql;
    		die($dieMessage);
    	} else {
			// theme
			if (isset($cfg["theme"]))
				$theme = $cfg["theme"];
			else if (isset($cfg["default_theme"]))
				$theme = $cfg["default_theme"];
			else
				$theme = "default";
			// template
			require_once("themes/".$theme."/index.php");
			require_once("inc/lib/vlib/vlibTemplate.php");
			$tmpl = @ tmplGetInstance($theme, "page.db.tmpl");
			@ $tmpl->setvar('debug_sql', $cfg["debug_sql"]);
			@ $tmpl->setvar('sql', $sql);
			$dbErrMsg = $db->ErrorMsg();
			@ $tmpl->setvar('ErrorMsg', $dbErrMsg);
			if (preg_match('/.*Query.*empty.*/i', $dbErrMsg))
				@ $tmpl->setvar('ExtraMsg', 'Database may be corrupted. Try to repair the tables.');
			else
				@ $tmpl->setvar('ExtraMsg', 'Always check your database settings in the config.db.php file.');
			@ $tmpl->pparse();
			exit();
    	}
	}
}

?>